var canvas;
var cntx;
var cnvBackBuffer;
var cntxBackBuffer;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    cnvBackBuffer=document.getElementById("backBuffer");
    cntxBackBuffer=cnvBackBuffer.getContext("2d");
    showAppTitle();
    
    imgLogo=document.getElementById("Logo");
    img=document.getElementById("imgToShow");
    
    initialValues();
    InitialiseCaptions();
    for(var i=0;i<NoOfCategories;i++){
        SelectedImage[i]=0;
    }
    InitialiseImageFileNames();
    initialiseGUI();
    nxtStepLeft=8;
    nxtStepTop=BottomPanelTop+20;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");

    initialiseEvents();
    drawBasicScreen();
}
    
function initialiseEvents(){
    $("#visualisation").contextmenu(function(evt){
        evt.preventDefault();
        evt.stopPropagation();
    });
    
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove(evt);
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp(evt);
    });
    
    $("#visualisation").on("mouseout",function(evt){
        imgLogo=document.getElementById("Logo");
        drawBasicScreen();
    });
}

function InitialiseImageFileNames(){
    FileName[0]="BTNPCards";
    FileName[1]="BTNMSDOS";
    FileName[2]="BTNWindows";
}

function initialValues(){
    width=canvas.width;
    height=canvas.height;
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-10;
    logoTop=BottomPanelTop+10;
    SectionTitle=BottomPanelTop-20;
    BTNLeft=Column1Left;
    BTNTop=TopPanelHeight+Column1Left;
}

function initialiseGUI(){
    logoLeft=width-logoWidth-10;
    logoTop=BottomPanelTop+10;
    imgLogo=document.getElementById("Logo");
    for(var i=0;i<NoOfCategories;i++){
        imgButtons[i]=document.getElementById(FileName[i]+"2");
        imgButtonsHovered[i]=document.getElementById(FileName[i]+"1");
        ButtonHover[i]=false;
    }
    InitialiseGUI_values();
}

function InitialiseGUI_values(){
    ImageTop=TopPanelHeight+imgButtons[0].height+Column1Top;
}

function drawBasicScreen(){
    //Φόντα οθόνης
    cntx.clearRect(0,0,canvas.width,canvas.height);
    
    cntx.fillStyle=MainAreaColor;
    cntx.fillRect(0,0,width,height);

    cntx.fillStyle=PanelColor;
    cntx.fillRect(0,0,width,TopPanelHeight);
    cntx.fillRect(0,BottomPanelTop,width,BottomPanelHeight);
    //Τίτλος εφαρμογής
    cnvsWrite(LetterColor,30,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    //Κουμπιά
    for(var i=0;i<NoOfCategories;i++){
        if (ButtonHover[i]){
            cntx.drawImage(imgButtonsHovered[i],ButtonLeft(i),BTNTop);
        }
        else {
            cntx.drawImage(imgButtons[i],ButtonLeft(i),BTNTop);
        }
    }
    drawButtonNext();

    //Εικόνες
    var imgMainLeft=(width-iw)/2;
    var imgMainTop=(SectionTitle-ImageTop-ih)/2+ImageTop;
    
    cntxBackBuffer.drawImage(img,0,0);
    ShowCaption();

    if(iw>0){
    	imgData=cntxBackBuffer.getImageData(0,0,iw,ih);
    	if(DrawingFinished){
            cntx.putImageData(imgData,imgMainLeft,imgMainTop);
    	}
    	else{
            timerLoop=setInterval(
                    function(){
                        drawSelectedImage(imgMainLeft,imgMainTop);
                    },
                    simSpeed);
    	}
    }
    
    cnvsWrite(LetterColor,fontSize-10,"Arial",-1,BottomPanelTop+67,"Κάνε διαδοχικά κλικ σε μια κατηγορία για να δεις ένα νέο παράδειγμα.");    

    //Πλαίσια μαύρου χρώματος
    cntx.strokeStyle="rgb(0,0,0)";
    cntx.beginPath();
    cntx.rect(0,0,width-1,TopPanelHeight);
    cntx.rect(0,TopPanelHeight,width-1,height-TopPanelHeight-BottomPanelHeight);
    cntx.rect(0,BottomPanelTop,width-1,BottomPanelHeight-1);
    if(iw>0){
        cntx.rect(imgMainLeft-1,imgMainTop-1,iw+1,ih+1);
    }
    cntx.stroke();
    cntx.drawImage(imgLogo,logoLeft,logoTop);
}

function drawSelectedImage(imgMainLeft,imgMainTop){
	imgData=cntxBackBuffer.getImageData(0,0,iw,ih);
	switch(effectSlctr){
	case 0:
	    effFadeIn();
		break;
	case 1:
		effHorizontal();
		break;
	case 2:
	    effVertical();
		break;
	case 3:
	    effRgbEffect();
		break;
	case 4:
	    effCircleEffect();
	    break;
        break;
	}
	//
	cntx.putImageData(imgData,imgMainLeft,imgMainTop);
}

function effFadeIn(){
	imgOpacity+=20;
	if(imgOpacity>255){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=3;i<imgData.data.length;i+=4){
			imgData.data[i]=imgOpacity;
		}
	}
}

function effHorizontal(){
	var noOfPixels=iw*ih;
	visiblePixels+=iw;
	if(visiblePixels>noOfPixels/2){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=visiblePixels;i<noOfPixels-visiblePixels;i++){
			imgData.data[4*i+3]=0;
		}
	}
}

function effVertical(){
	visibleColumns+=2;
	if(visibleColumns>iw/2){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=0;i<=ih;i++){
			for(var j=visibleColumns;j<=iw-visibleColumns;j++){
				imgData.data[((i-1)*iw+j)*4+3]=0;
			}
		}
	}
}

function effRgbEffect(){
	rgbEffectStage++;
	if(rgbEffectStage>2){
		DrawingFinished=true;
	    clearInterval(timerLoop);
	}
	else{
		for(var i=0;i<iw*ih;i++){
			for(var component=rgbEffectStage;component<3;component++){
				imgData.data[4*i+component]=0;
			}
		}
	}
}

function effCircleEffect(){
    effectRadius+=10;
    if(effectRadius>Math.sqrt(Math.pow(iw,2)+Math.pow(ih,2))/radiusDenominatior){
        DrawingFinished=true;
        clearInterval(timerLoop);
    }
    else{
        for(var i=0;i<=ih;i++){
            for(var j=0;j<=iw;j++){
                var r=Math.sqrt(Math.pow(i-yCenterOffset,2)+Math.pow(j-xCenterOffset,2));
                if(r>effectRadius){
                    imgData.data[4*((i-1)*iw+j)+3]=0;
                }
            }
        }
    }
}

function getImagesData(){
    imgData=cntx.getImageData(width+10,10,iw,ih);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (ButtonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function ButtonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseMove(evt){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else {
        imgLogo=document.getElementById("Logo");
        ShowProgramID=false;
    }
    
    for(var i=0;i<NoOfCategories;i++) {
        ButtonHover[i]=false;
        if(my>TopPanelHeight+Column1Top && my<TopPanelHeight+Column1Top+imgButtons[i].height){
            if (mx>=ButtonLeft(i) && mx<=ButtonRight(i)) ButtonHover[i]=true;
        }
    }
    if(DrawingFinished)drawBasicScreen();
    //console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(evt){
    evt.preventDefault();
    isButtonPressed=false;
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight){
        if(MyInfo){
            ShowProgramID=!ShowProgramID;
        }
        else {
            showHTML();
        }
        drawBasicScreen();
    }
    
    if(DrawingFinished){
        var Found=false;

        if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight){
            Found=true;
        }
        
        var i=0;
        while(i<NoOfCategories && !Found){
            if (ButtonHover[i]){
                Found=true;
                SelectedCategory=i;
            }
            else {
                i++;
            }
        }
        if(Found){
            OpaquePercent=0;
            SelectImage(SelectedCategory);
            NextPic=true;
        }
        drawBasicScreen();
    }
}

function SelectImage(i){
    var SelectedFile;
    var AvailableFiles,FileNo;
    if (i==0){
        SelectedFile="PCards";
        AvailableFiles=30;
    }
    else if (i==1){
        SelectedFile="MSDOS";
        AvailableFiles=16;
    }
    else {
        SelectedFile="Windows";
        AvailableFiles=17;
    }
    do{
        FileNo=parseInt(Math.random()*AvailableFiles+1);
    }while(FileNo==SelectedImage[i] || FileNo>AvailableFiles);
    SelectedImage[i]=FileNo;
    
    var downloadingImage=new Image();
    downloadingImage.onload=function(){
        img.src=this.src;
        iw=img.width;
        ih=img.height;
    	DrawingFinished=false;
    	selectEffect();
        drawBasicScreen();
    };
    
    //φόρτωση επιλεγμένης εικόνας
    downloadingImage.src="img/"+SelectedFile+FileNo+".JPG";
    
    captionToShow=AvailableCaptions[i][FileNo-1];
}

function ShowCaption(){
    if(captionToShow!=""){
        cnvsWrite(LetterColor,16,"Arial",-1,BottomPanelTop+20,Sections[SelectedCategory]);
        cnvsWrite(LetterColor,18,"Arial",-1,BottomPanelTop+42,captionToShow);
    }
}

function InitialiseCaptions(){
    Sections[0]="Διάτρητες Κάρτες";
    Sections[1]="Περιβάλλον Προγραμματισμού με Κείμενο";
    Sections[2]="Περιβάλλον Προγραμματισμού με Γραφικά / Οπτικός Προγραμματισμός";
    AvailableCaptions[0][0]="Κατάλληλες ακόμη και για αυτοματοποιημένη αναπαραγωγή μουσικής";
    AvailableCaptions[0][1]="Διάτρητες κάρτες για Διαδικασία Ψηφοφορίας";
    AvailableCaptions[0][2]="Το 'backup' μιας παλιότερης εποχής";
    AvailableCaptions[0][3]="Διάτρητη κάρτα της IBM";
    AvailableCaptions[0][4]="Διάτρητη κάρτα για αυτοματοποιημένη δημιουργία πλεκτών";
    AvailableCaptions[0][5]="Διάτρητη κάρτα του Semen Korsakov";
    AvailableCaptions[0][6]="Κυλινδρική κεφαλή δημιουργίας διάτρητων καρτών";
    AvailableCaptions[0][7]="Διάτρητη κάρτα τις IBM με 96 στήλες";
    AvailableCaptions[0][8]="Διάτρητη κάρτα με πληροφορίες στο Δυαδικό Σύστημα";
    AvailableCaptions[0][9]="Διάτρητη κάρτα για μηχανολογική σχεδίαση";
    AvailableCaptions[0][10]="Πρόγραμμα γραμμένο σε FORTRAN";
    AvailableCaptions[0][11]="Διάτρητη κάρτα με εμφανή τη φθορά από το χρόνο και τη χρήση";
    AvailableCaptions[0][12]="Διάτρητη κάρτα που ήταν σε χρήση στα τέλη του 20ου αιώνα";
    AvailableCaptions[0][13]="Η Κάρτα 90 στηλών της Powers/Remington Rand";
    AvailableCaptions[0][14]="Κάρτα 80 στηλών με το Σύνολο Χαρακτήρων EBCDIC";
    AvailableCaptions[0][15]="Ηλεκτρική Μηχανή Ανάγνωσης του Hollerith";
    AvailableCaptions[0][16]="Εκπαίδευση στη χρήση Μηχανών Διάτρησης Καρτών";
    AvailableCaptions[0][17]="Μηχανή Διάτρησης";
    AvailableCaptions[0][18]="Λογιστική Μηχανή Ανάγνωσης μεγάλου πλήθους Καρτών";
    AvailableCaptions[0][19]="Ηλεκτρικός Αναγνώστης Διάτρητων Καρτών";
    AvailableCaptions[0][20]="Τα μεγάλα προγράμματα εκτείνονται σε πολλές Κάρτες";
    AvailableCaptions[0][21]="Αναγνώστης Καρτών στο Πανεπιστήμιο του Essex";
    AvailableCaptions[0][22]="Χειριστής της μηχανής του Hollerith";
    AvailableCaptions[0][23]="Αναγνώστης Καρτών της IBM (1959)";
    AvailableCaptions[0][24]="Αναγνώστες από Κάρτες και Μαγνητοταινίες (1971)";
    AvailableCaptions[0][25]="Ηλεκτρομαγνητικός αναγνώστης για 12.000 (!) Κάρτες (IBM 1952)";
    AvailableCaptions[0][26]="Μια... 'χούφτα' εντολές";
    AvailableCaptions[0][27]="Αναγνώστες από Κάρτες και Μαγνητοταινίες (1971)";
    AvailableCaptions[0][28]="Αναγνώστης Καρτών στο English Electric London Computing Centre";
    AvailableCaptions[0][29]="Συσκευή Διάτρησης Καρτών";
    AvailableCaptions[0][30]="Συσκευή Διάτρησης Καρτών";
    AvailableCaptions[1][0]="Περιβάλλον της Turbo Pascal (1987)";
    AvailableCaptions[1][1]="Εντοπισμός σφάλματος στο περιβάλλον της Turbo C";
    AvailableCaptions[1][2]="Αποθήκευση Πηγαίου Αρχείου στην Turbo Pascal";
    AvailableCaptions[1][3]="Μεταγλώττιση Προγράμματος στην Turbo Pascal";
    AvailableCaptions[1][4]="Εντοπισμός σφάλματος στο περιβάλλον της Turbo Pascal";
    AvailableCaptions[1][5]="Εντοπισμός σφαλμάτων στην Turbo C";
    AvailableCaptions[1][6]="Τα παλιά Περιβάλλοντα μπορούν να χρησιμοποιηθούν και σε Windows";
    AvailableCaptions[1][7]="Turbo Prolog Έκδοση 2";
    AvailableCaptions[1][8]="Περιβάλλον τη γλώσσας BASIC";
    AvailableCaptions[1][9]="Πρόγραμμα σε BASIC με αρίθμηση γραμμών";
    AvailableCaptions[1][10]="Turbo BASIC Έκδοση 1";
    AvailableCaptions[1][11]="Αντικειμενοστρεφής Προγραμματισμός σε C++";
    AvailableCaptions[1][12]="Αυτόματος χρωματισμός κώδικα για μεγαλύτερη σαφήνεια (Pascal)";
    AvailableCaptions[1][13]="Turbo PASCAL έκδοση 5.5 σε Υπολογιστή με δίχρωμη οθόνη";
    AvailableCaptions[1][14]="Turbo C++ έκδοση 3";
    AvailableCaptions[1][15]="Παράδειγμα απλού προγράμματος σε Pascal";
    AvailableCaptions[2][0]="Έκδοση C++ με εμπλουτισμένο Προγραμματιστικό Περιβάλλον";
    AvailableCaptions[2][1]="Οπτικός Προγραμματισμός";
    AvailableCaptions[2][2]="Παραθυρικό Περιβάλλον προγραμματισμού της SmallTalk";
    AvailableCaptions[2][3]="Σύγχρονο προγραμματιστικό περιβάλλον της Java";
    AvailableCaptions[2][4]="Οπτικός προγραμματισμός σε Scratch";
    AvailableCaptions[2][5]="Προγραμματιστικό Περιβάλλον με πλήθος βοηθητικών εργαλείων";
    AvailableCaptions[2][6]="Περιβάλλον διαδικτυακού προγραμματισμού";
    AvailableCaptions[2][7]="Περιβάλλον NetBeans για προγραμματισμό σε Java";
    AvailableCaptions[2][8]="Περιβάλλον προγραμματισμού Perl";
    AvailableCaptions[2][9]="Περιβάλλον προγραμματισμού php";
    AvailableCaptions[2][10]="Περιβάλλον προγραμματισμού Visual Studio";
    AvailableCaptions[2][11]="Δημιουργία διεπαφής (interface) με οπτικό προγραμματισμό";
    AvailableCaptions[2][12]="Περιβάλλον προγραμματισμού Visual Studio";
    AvailableCaptions[2][13]="Ποικιλία έτοιμων τύπων εφαρμογών";
    AvailableCaptions[2][14]="Οπτικός Προγραμματισμός σε Windows";
    AvailableCaptions[2][15]="Προγραμματισμός σε περιβάλλον EasyLogo";
    AvailableCaptions[2][16]="Προγραμματισμός σε περιβάλλον MicroWorldsPro";
}

function ButtonLeft(i){
    return Column1Left+i*imgButtons[i].width;
}

function ButtonRight(i){
    return Column1Left+(i+1)*imgButtons[i].width;
}

function selectEffect(){
    //Επιλογή εφφέ
    effectSlctr=parseInt(Math.random()*noOfEffects);
    //Αρχικοποίηση παραμέτρων
    imgOpacity=0;
    visiblePixels=0;
    visibleColumns=0;
    rgbEffectStage=-1;
    effectRadius=0;
    simSpeed=10;
    switch(effectSlctr){
        case 3: //rgb
            simSpeed=200;
            break;
        case 4: //circle
            var centerSlctr=Math.random();
            if(centerSlctr<0.33){
                xCenterOffset=0;
                yCenterOffset=0;
                radiusDenominatior=1;
            }
            else if(centerSlctr<0.66){
                xCenterOffset=iw/2;
                yCenterOffset=ih/2;
                radiusDenominatior=2;
            }
            else{
                xCenterOffset=iw;
                yCenterOffset=ih;
                radiusDenominatior=1;
            }
            break;
    }
}